/***************************************************************************
                          FILENAME  -  description                              
                             -------------------                                         
    begin                : DATE                                           
    copyright            : (C) YEAR by AUTHOR                         
    email                : EMAIL                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef _CWIZARDCONVERSION_H_
#define _CWIZARDCONVERSION_H_

#include <qwidget.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qradiobutton.h>
#include <qbuttongroup.h>

#include <kiconloader.h>
#include <kapp.h>
#include <klocale.h>
#include <kfiletreeview.h>
#include <kwizard.h>

#include <qdialog.h>

/**
  *@author Eric Coquelle
  */

class CWizardConversion : public KWizard  {
   Q_OBJECT
public: 
	CWizardConversion(QWidget *parent=0, const char *name=0);
	~CWizardConversion();

    QString getConversionTargetDirectory() { return selectedpath; };
    int getNewArchiveType() { return newarchivetype; };
    
protected: 
	void initDialog();
	void setupPageOne();
    void setupPageTwo();   
    void setupPageThree();
    
protected slots:
  void accept();
  
private: 
    QButtonGroup *QButtonGroup_1;
    QRadioButton *radiotar;
    QRadioButton *radiotargz;
    QRadioButton *radiotarbz2;
    QRadioButton *radiobz2;
    QRadioButton *radiogz;
    QRadioButton *radiozip;
    QRadioButton *radiorar;
    QRadioButton *radiolha;
    QRadioButton *radio7z;
    QRadioButton *radioarj;
    QRadioButton *radiosit;
    
    QWidget* wpageone;
    QWidget* wpagetwo;
    QWidget* wpagethree;
    KFileTreeView* treeview;
    QString selectedpath;
    int newarchivetype;
};

#endif
