/***************************************************************************
                          FILENAME  -  description                              
                             -------------------                                         
    begin                : DATE                                           
    copyright            : (C) YEAR by AUTHOR                         
    email                : EMAIL                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef _CWIZARDSTEP1INSTALLATION_H_
#define _CWIZARDSTEP1INSTALLATION_H_

#include <qwidget.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qlineedit.h>
#include <qgroupbox.h>
#include <qradiobutton.h>
#include <qbuttongroup.h>

#include <kwizard.h>
#include <kiconloader.h>

/**
  *@author Eric Coquelle
  */


class CWizardInstallation : public KWizard  {
   Q_OBJECT
public: 
	CWizardInstallation(QWidget *parent=0, const char *name=0);
	~CWizardInstallation();
	
    int getTypeInstall() { return typeInstall; };
    QString getConfigure() { return leconfigure->text(); };
    QString getArguments() { return learguments->text(); };
    QString getMake() { return lemake->text(); };
    QString getMakeInstall() { return lemakeinstall->text(); };
       
private:
  void setupPageOne();
  void setupPageTwo();
  void setupPageThree();
     
protected slots: // Protected slots
  /** the user can su root, so we can make install */
  void slotActiveInstall(int);

private: 
    QLabel *QLabel_9;
    QLabel *QLabel_10;
    QLabel *labelwizard2i;
    
    int typeInstall;
    QLabel *label2_0;
    QLabel *label2_1;
    QLineEdit *leconfigure;
    QLabel *label2_2;
    QLineEdit *learguments;
    QLabel *label2_3;
    QLineEdit *lemake;
    QGroupBox *QGroupBox_2;
    QButtonGroup *QButtonGroup_1;
    QRadioButton *radioroot;
    QRadioButton *radiouser;
    QRadioButton *radiopasinstall;
    QLineEdit *lemakeinstall;
    QLabel *label2_4;

};

#endif
