/***************************************************************************
                          FILENAME  -  description                              
                             -------------------                                         
    begin                : DATE                                           
    copyright            : (C) 2006 by Eric Coquelle                         
    email                : EMAIL                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef _CWIZARDSFX_H_
#define _CWIZARDSFX_H_

#include <qwidget.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qlineedit.h>
#include <qgroupbox.h>
#include <qradiobutton.h>
#include <qbuttongroup.h>

#include <kwizard.h>
#include <kiconloader.h>

/**
  *@author Eric Coquelle
  */


class CWizardSfx : public KWizard  {
   Q_OBJECT
public:
  CWizardSfx(QWidget *parent=0, const char *name=0);
  ~CWizardSfx();
  
  int getSfxType();
  QString getSfxName();
	
protected slots:
  /**Check for Page 2 and add a warning message if the Sfx module cannot be found*/
  void slotPageChanged(const QString& pagetitle);
  void slotBrowse();
  virtual void accept();

private:
  void setupPageOne();
  void setupPageTwo();
  void setupPageThree();

private: 
    QRadioButton *radiouniversal;
    QRadioButton *radio7zwin;
    QLabel* QLabel_3;
    QLabel* QLabel_4;
    QPushButton* bpath;
    QLineEdit* lepathsfx;
    QWidget* pagetwo;
    QString titlepageone;
    QString titlepagetwo;
};

#endif
