/***************************************************************************
                          karchiveurview.h  -  description
                             -------------------
    begin                : mer jun 14 00:26:31 CEST 2000
    copyright            : (C) 2000 by Eric Coquelle
    email                : coquelle@caramail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#define STANDARD_DATE				0
#define LOCALISED_DATE      1
#define LOCALISED_FULL_DATE 2


#ifndef KARCHIVEURVIEW_H
#define KARCHIVEURVIEW_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

// include files for Qt
#include <qwidget.h>
#include <qlistview.h>

#include <kiconloader.h>
#include <klocale.h>
#include <kglobal.h>
#include <qdragobject.h>
#include <qdatetime.h>

#include <stdio.h>

#include "clistview.h"

//class KarchiveurDoc;

/** The KarchiveurView class provides the view widget for the KarchiveurApp instance.	
 * The View instance inherits QWidget as a base class and represents the view object of a KTMainWindow. As KarchiveurView is part of the
 * docuement-view model, it needs a reference to the document object connected with it by the KarchiveurApp class to manipulate and display
 * the document structure provided by the KarchiveurDoc class.
 * 	
 * @author Source Framework Automatically Generated by KDevelop, (c) The KDevelop Team.
 * @version KDevelop version 0.4 code generation
 */
class KarchiveurView : public CListView
{
Q_OBJECT
public:
	/** Constructor for the main view */
	KarchiveurView(QWidget *parent = 0, const char *name=0);

	/** Destructor for the main view */
	~KarchiveurView();

	/** contains the implementation for printing functionality */
	void print(QPrinter *pPrinter);
  /** Set or not an alternate background */
  void setAlternateBackground(bool);

protected:
  /** Accept any drop event ! */
//  void dragEnterEvent(QDragEnterEvent* e);
  bool acceptDrag(QDropEvent* e) const;

protected slots:
  /** A drop occurs */
  void slotDropped (QDropEvent * e, QListViewItem *after);
};

#endif // KARCHIVEURVIEW_H
